System [00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00] 1.0.3300.0 1.0.5000.0 2.0.0.0 4.0.0.0 Gtk# is thread aware, but not thread safe; See the <link location="node:gtk-sharp/programming/threads">Gtk# Thread Programming</link> for details. System.ComponentModel.Component System.ComponentModel.ToolboxItem(false) System.Runtime.InteropServices.ComVisible(true)

A can be used to create and retrieve instances of code generators and code compilers. Code generators can be used to generate code in a particular language, and code compilers can be used to compile code into assemblies.

In the dnprdnext, the methods made available in the code generator and code compiler are available directly from the code provider. You do not need to call or to access the methods, and those methods are marked as obsolete. This applies to preexisting as well as new code provider implementations.

A implementation typically provides code generation and/or code compilation interfaces for generating code and managing compilation for a single programming language. Several languages are supported by implementations that ship with the winsdklong. These languages include C#, Visual Basic, C++, and JScript. Developers or compiler vendors can implement the and interfaces and provide a that extends CodeDOM support to other programming languages.

The <system.codedom> in the machine configuration file (Machine.config) provides a mechanism for developers and compiler vendors to add configuration settings for additional implementations.

The class provides static methods to discover and enumerate the implementations on a computer. The method returns the settings for all implementations on a computer. The method returns the settings for a specific implementation, based on the programming language name. The method returns an instance of a implementation for a specific language.

For more details on language provider settings in the configuration file, see Compiler and Language Provider Settings Schema.

This class makes a link demand and an inheritance demand at the class level. A is thrown if either the immediate caller or the derived class does not have full trust permission. For details about security demands, see Link Demands and Inheritance Demands.

Provides a base class for implementations. This class is abstract.

- Constructor
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  To be added

  Initializes a new instance of the class.

- Method
  2.0.0.0
  4.0.0.0
  System.CodeDom.Compiler.CompilerResults `` `System.ParamArray`

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Compiles an assembly based on the trees contained in the specified array of objects, using the specified compiler settings.

  A object that indicates the results of the compilation.

  A object that indicates the settings for the compilation. An array of type that indicates the code to compile.
- Method
  2.0.0.0
  4.0.0.0
  System.CodeDom.Compiler.CompilerResults `` `System.ParamArray`

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Compiles an assembly from the source code contained in the specified files, using the specified compiler settings.

  A object that indicates the results of compilation.

  A object that indicates the settings for the compilation. An array of the names of the files to compile.
- Method
  2.0.0.0
  4.0.0.0
  System.CodeDom.Compiler.CompilerResults `` `System.ParamArray`

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Compiles an assembly from the specified array of strings containing source code, using the specified compiler settings.

  A object that indicates the results of compilation.

  A object that indicates the compiler settings for this compilation. An array of source code strings to compile.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Obsolete("ICodeCompiler is obsolete")
  System.CodeDom.Compiler.ICodeCompiler

  This method is obsolete in the dnprdnext. The recommended alternative is to call the methods that are directly available in the code provider.

  When overridden in a derived class, creates a new code compiler.

  An that can be used for compilation of based source code representations.

- Method
  2.0.0.0
  4.0.0.0
  System.String ``

  tests whether the identifier conflicts with any reserved or language keywords, and if so, returns an equivalent name with language-specific escape code formatting. This is referred to an escaped identifier. The escaped identifier contains the same but has escape-code formatting added to differentiate the identifier from the keyword. Two implementation examples are preceding the with "@" or bracketing the with "[" and "]".

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Creates an escaped identifier for the specified value.

  The escaped identifier for the value.

  The string for which to create an escaped identifier.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Obsolete("ICodeGenerator is obsolete")
  System.CodeDom.Compiler.ICodeGenerator

  This method is obsolete in the dnprdnext. The recommended alternative is to call the methods that are directly available in the class.

  When overridden in a derived class, creates a new code generator.

  An that can be used to generate based source code representations.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.CodeDom.Compiler.ICodeGenerator ``

  This method uses the specified for output. This method supports more optimized code generation that incrementally updates the source code.

  The base class implementation calls the method, which is obsolete in the dnprdnext and results in a if an object is not returned.

  When overridden in a derived class, creates a new code generator using the specified for output.

  An that can be used to generate based source code representations.

  A to use to output.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.CodeDom.Compiler.ICodeGenerator ``

  This method uses the specified file name for output.

  The base class implementation calls the method, which is obsolete in the dnprdnext and results in a if an object is not returned.

  When overridden in a derived class, creates a new code generator using the specified file name for output.

  An that can be used to generate based source code representations.

  The file name to output to.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Obsolete("ICodeParser is obsolete")
  System.CodeDom.Compiler.ICodeParser To be added

  When overridden in a derived class, creates a new code parser.

  An that can be used to parse source code. The base implementation always returns null.

- Method
  2.0.0.0
  4.0.0.0
  System.Runtime.InteropServices.ComVisible(false)
  System.CodeDom.Compiler.CodeDomProvider ``

  This method is most commonly used to create an instance of a code provider in an application that may optionally use one of several providers. allows you to specify at run time the code provider you wish to instantiate. If you know at design time which code provider is to be used, you should create an instance of that code provider rather than use the method.

  The method returns a instance for a specific language name; it is similar to calling the method with the language provider type. Use when you want to dynamically find a configured provider implementation for a language name.

  If more than one provider implementation is configured for the language name, returns a provider instance for the last matching configuration element.

  Use the method overload when you want a specific language provider implementation. For example, use the method to get a provider instance that supports the language name "CSharp"; use the method overload to get a provider instance specifically for the implementation. You should use the method if you have multiple code providers for a language and you desire to instantiate a specific code provider.

  The method checks whether at least one provider implementation supports a specific language. You can validate a language name using before passing it to . If you pass an unsupported language name to a is thrown.

  The method can be used to determine all implementations on a computer, including additional implementations provided by developers and compiler vendors that are identified in the <system.codedom> in the machine configuration file (Machine.config).

  The method returns an instance of a implementation for a specific language.

  Language names are case-insensitive.

  Gets a instance for the specified language.

  A CodeDOM provider that is implemented for the specified language name.

  The language name.
- Method
  4.0.0.0
  System.Runtime.InteropServices.ComVisible(false)
  System.CodeDom.Compiler.CodeDomProvider `` ``

  This method is most commonly used to create an instance of a code provider in an application that may optionally use one of several providers. enables you to specify at run time the version of the code provider you want to instantiate. If you know at design time which code provider is to be used, you should create an instance of that code provider instead of using the method.

  Use when you want to dynamically find a configured provider implementation for a specific language and options. Language names are case-insensitive. For information about supported provider options, see the specific CodeDOM provider documentation.

  For information about validating a provider and calling a provider if more than one provider implementation is configured for the language name, see the Remarks section of the method.

  Gets a instance for the specified language and provider options.

  A CodeDOM provider that is implemented for the specified language name and options.

  The language name. A collection of provider options from the configuration file.
- Method
  2.0.0.0
  4.0.0.0
  System.String ``

  tests whether the identifier conflicts with reserved or language keywords, and if so, attempts to return a valid identifier name that does not conflict. Usually the returned identifier is only slightly modified to differentiate the identifier from the keyword; for example, the name might be preceded by the underscore ("_") character.

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Creates a valid identifier for the specified value.

  A valid identifier for the specified value.

  The string for which to generate a valid identifier.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.String To be added: an object of type 'string'

  This property is used by code generators and code compilers to indicate what file extensions should be generated or used.

  Gets the default file name extension to use for source code files in the current language.

- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` ``

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Generates code for the specified Code Document Object Model (CodeDOM) compilation unit and sends it to the specified text writer, using the specified options.

  A for which to generate code. The to which the output code is sent. A that indicates the options to use for generating code.
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` ``

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Generates code for the specified Code Document Object Model (CodeDOM) expression and sends it to the specified text writer, using the specified options.

  A object that indicates the expression for which to generate code. The to which output code is sent. A that indicates the options to use for generating code.
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` ``

  The base class implementation throws a . See for documentation describing an implementation of this method.

  Generates code for the specified Code Document Object Model (CodeDOM) member declaration and sends it to the specified text writer, using the specified options.

  A object that indicates the member for which to generate code. The to which output code is sent. A that indicates the options to use for generating code.
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` ``

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Generates code for the specified Code Document Object Model (CodeDOM) namespace and sends it to the specified text writer, using the specified options.

  A object that indicates the namespace for which to generate code. The to which output code is sent. A that indicates the options to use for generating code.
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` ``

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Generates code for the specified Code Document Object Model (CodeDOM) statement and sends it to the specified text writer, using the specified options.

  A containing the CodeDOM elements for which to generate code. The to which output code is sent. A that indicates the options to use for generating code.
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` ``

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Generates code for the specified Code Document Object Model (CodeDOM) type declaration and sends it to the specified text writer, using the specified options.

  A object that indicates the type for which to generate code. The to which output code is sent. A that indicates the options to use for generating code.
- Method
  2.0.0.0
  4.0.0.0
  System.Runtime.InteropServices.ComVisible(false)
  System.CodeDom.Compiler.CompilerInfo[]

  Use the method to enumerate the language provider settings on a computer.

  In the dnprdnext, the default language providers supplied by the .NET Framework are not specified in the <system.codedom> compiler configuration section and cannot be removed, so this method returns information about the default providers and any specified in the configuration file.

  Returns the language provider and compiler configuration settings for this computer.

  An array of type representing the settings of all configured implementations.

- Method
  2.0.0.0
  4.0.0.0
  System.Runtime.InteropServices.ComVisible(false)
  System.CodeDom.Compiler.CompilerInfo ``

  The <system.codedom> in the machine configuration file contains the language provider and compiler configuration settings for each implementation on the computer. For information about machine configuration files, see the Machine Configuration Files section in Configuration Files. The method searches each provider configuration element for the specified language name. The returned instance contains the configured language provider and compiler settings.

  The method checks whether at least one provider implementation supports a specific language. You can validate a language name using before passing it to . This prevents throwing a when you access the instance for an unsupported language name.

  If more than one provider implementation is configured for the input language name, returns the settings from the last matching provider configuration element.

  Language names are case-insensitive.

  Returns the language provider and compiler configuration settings for the specified language.

  A object populated with settings of the configured implementation.

  A language name.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.TypeConverter ``

  A derived class can override this method to provide specific types of type converters for specific data types.

  Gets a for the specified data type.

  A for the specified type, or null if a for the specified type cannot be found.

  The type of object to retrieve a type converter for.
- Method
  2.0.0.0
  4.0.0.0
  System.Runtime.InteropServices.ComVisible(false)
  System.String ``

  The <system.codedom> in the machine configuration file (Machine.config) contains the language provider and compiler configuration settings for each implementation on the computer. The method searches each provider configuration element for the specified file name extension.

  The method checks whether at least one provider implementation supports a specific file name extension. You can validate a file name extension using before passing it to . This prevents from throwing a for an unsupported file name extension.

  If a provider implementation supports the input file name extension, and there are multiple supported languages configured for that provider, then returns the first language name for that provider. If more than one provider implementation is configured for the input file name extension, returns the language name from the last matching provider configuration element.

  Language names and file name extensions are case-insensitive.

  Returns a language name associated with the specified file name extension, as configured in the compiler configuration section.

  A language name associated with the file name extension, as configured in the compiler configuration settings.

  A file name extension.
- Method
  2.0.0.0
  4.0.0.0
  System.String ``

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Gets the type indicated by the specified .

  A text representation of the specified type, formatted for the language in which code is generated by this code generator. In Visual Basic, for example, passing in a for the type will return "Integer".

  A that indicates the type to return.
- Method
  2.0.0.0
  4.0.0.0
  System.Runtime.InteropServices.ComVisible(false)
  System.Boolean ``

  The <system.codedom> in the machine configuration file (Machine.config) contains the language provider and compiler configuration settings for each implementation on the computer. The method searches the provider configuration elements for the specified file name extension.

  File name extensions are case-insensitive.

  Tests whether a file name extension has an associated implementation configured on the computer.

  true if a implementation is configured for the specified file name extension; otherwise, false.

  A file name extension.
- Method
  2.0.0.0
  4.0.0.0
  System.Runtime.InteropServices.ComVisible(false)
  System.Boolean ``

  The <system.codedom> in the machine configuration file (Machine.config) contains the language provider and compiler configuration settings for each implementation on the computer. The method searches the provider configuration elements for the specified language name.

  Language names are case-insensitive.

  Tests whether a language has a implementation configured on the computer.

  true if a implementation is configured for the specified language; otherwise, false.

  The language name.
- Method
  2.0.0.0
  4.0.0.0
  System.Boolean ``

  This method tests whether an identifier is valid. The method is provider specific. Identifiers that are valid for one provider might not be valid for other providers. If contains characters outside of the ASCII character range, check the identifier for all the languages that might be used to compile the code.

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Returns a value that indicates whether the specified value is a valid identifier for the current language.

  true if the parameter is a valid identifier; otherwise, false.

  The value to verify as a valid identifier.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.CodeDom.Compiler.LanguageOptions To be added: an object of type 'LanguageOptions' To be added

  Gets a language features identifier.

- Method
  2.0.0.0
  4.0.0.0
  System.CodeDom.CodeCompileUnit ``

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Compiles the code read from the specified text stream into a .

  A that contains a representation of the parsed code.

  A object that is used to read the code to be parsed.
- Method
  2.0.0.0
  4.0.0.0
  System.Boolean `` To be added.

  This method can be called with a number of flags at once to test for a set of capabilities by joining a set of appropriate capability flags together with a binary OR operator (|).

  In the .NET Framework versions 1.0 and 1.1, this method is provided by the implementation that is returned by the method of the provider. In version 2.0, this method can be called directly on the code provider even if it is not overridden by the code provider. If the code provider does not override this method, the implementation is called by the base class.

  Returns a value indicating whether the specified code generation support is provided.

  true if the specified code generation support is provided; otherwise, false.